<?php 
/**
 * Plugin Name: Simple ABTesting (Matomo Plugin)
 * Plugin URI: http://plugins.matomo.org/SimpleABTesting
 * Description: A free and simple A/B testing plugin. Insert custom CSS / JS for your variant and you are done.
 * Author: No Frills Plugins
 * Author URI: https://www.nofrillsplugins.com/matomo-simple-ab-testing
 * Version: 0.1.95
 */
?><?php

namespace Piwik\Plugins\SimpleABTesting;

use Piwik\Common;
use Piwik\Db;
use Piwik\Plugins\SimpleABTesting\Generator;
use Exception;

 
if (defined( 'ABSPATH')
&& function_exists('add_action')) {
    $path = '/matomo/app/core/Plugin.php';
    if (defined('WP_PLUGIN_DIR') && WP_PLUGIN_DIR && file_exists(WP_PLUGIN_DIR . $path)) {
        require_once WP_PLUGIN_DIR . $path;
    } elseif (defined('WPMU_PLUGIN_DIR') && WPMU_PLUGIN_DIR && file_exists(WPMU_PLUGIN_DIR . $path)) {
        require_once WPMU_PLUGIN_DIR . $path;
    } else {
        return;
    }
    add_action('plugins_loaded', function () {
        if (function_exists('matomo_add_plugin')) {
            matomo_add_plugin(__DIR__, __FILE__, true);
        }
    });
}

class SimpleABTesting extends \Piwik\Plugin
{
    public function install()
    {
        try {
            $sql = "CREATE TABLE " . Common::prefixTable('ab_tests') . " (
                    `id` int(11) NOT NULL AUTO_INCREMENT,
                    `idsite` int(11) NOT NULL,
                    `name` varchar(255) NOT NULL,
                    `hypothesis` text,
                    `description` text,
                    `domain` varchar(255) NOT NULL,
                    `from_date` date NOT NULL,
                    `to_date` date NOT NULL,
                    `url_regex` text,
                    `css_insert` text,
                    `js_insert` text,
                    `custom_dimension` int(11) NOT NULL,
                    PRIMARY KEY (`id`),
                    UNIQUE KEY `unique_name` (`name`)
                    )  DEFAULT CHARSET=utf8 ";
            Db::exec($sql);

            $generator = new Generator();
            $generator->regenerateJS();
        } catch (Exception $e) {
            // ignore error if table already exists (1050 code is for 'table already exists')
            if (!Db::get()->isErrNo($e, '1050')) {
                throw $e;
            }
        }
    }

    public function uninstall()
    {
        Db::dropTables(Common::prefixTable('ab_tests'));
    }
}
